# Latest commit on 
# git clone https://github.com/aircrack-ng/rtl8188eus/tree/v5.7.6.1
# noch nicht in kernel-5.6 benutzbar
# git archive 

%global	module	8188eus
%global pname rtl%{module}

Name:		dkms-%{pname}
Version:	5.7.6.1
Release:	%mkrel 2
Source0:	%{pname}-%{version}.tar.xz
Patch0:		rtl8188eus-5.7.6.1-MakeFile.patch
Patch1:		rtl8188eus-5.7.6.1-ioctl_cfg8021.c-kernel5.6.patch
License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/aircrack-ng/rtl8188eus/tree/v5.7.6.1
Summary:	dkms package for stand-alone RTL8188EUS realtek driver
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
BuildRequires:  gcc
BuildRequires:  make

Requires: 	kernel
Requires:   gcc >= 9.2.0
Requires(post):		dkms
Requires(preun):	dkms

Provides:	%{name}-%{version}
Obsoletes:	%{name} < %{version}-%{release}

%description
rtl8188eus v5.3.9
Realtek rtl8188eus & rtl8188eu & rtl8188etv WiFi drivers
Supports
    Android 7
    MESH Support
    Monitor mode
    Frame injection
    Up to kernel v5.3+ ... And a bunch of various wifi chipsets

Howto build/install
    You will need to blacklist another driver in order to use this one.
    "echo "blacklist r8188eu" > "/etc/modprobe.d/realtek.conf"
    "make && make install"
    Reboot in order to blacklist and load the new driver/module.

MONITOR MODE howto
Use these steps to enter monitor mode.

$ sudo airmon-ng check-kill
$ sudo ip link set <interface> down
$ sudo iw dev <interface> set type monitor

Frame injection test may be performed with (after kernel v5.2 scanning is slow,
run a scan or simply an airodump-ng first!)
$ aireplay -9 <interface>

NetworkManager configuration
Add these lines below to "NetworkManager.conf" and ADD YOUR ADAPTER MAC below
[keyfile] This will make the Network-Manager ignore the device,
and therefor don't cause problems.

[device]
wifi.scan-rand-mac-address=no

[ifupdown]
managed=false

[connection]
wifi.powersave=0

[main]
plugins=keyfile

[keyfile]
unmanaged-devices=mac:A7:A7:A7:A7:A7


%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;
%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/

%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME="%{pname}"
DEST_MODULE_LOCATION="/kernel/3rdparty/%{pname}"
MAKE="'make' SKIP_STACK_VALIDATION=1 all"
AUTOINSTALL="yes"
CLEAN="'make' clean"
EOF

mkdir -p %{buildroot}/etc/modprobe.d
%__cat <<EOF > %{buildroot}/etc/modprobe.d/50-8188eus.conf
blacklist r8188eu
EOF

%post -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
/sbin/modprobe %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
echo "%{pname}" >> /etc/modprobe.preload
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{pname} >/dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload >/dev/null 2>&1
sed -i '/%{pname}/ d' /etc/modprobe.preload
fi
## so prevent we not have empty folders in kernel-tree for next mklivecd ##
if [ ! -f /lib/modules/*/kernel/3rdparty/%{pname}/* ]; then
rm -r /lib/modules/*/kernel/3rdparty/%{pname} >/dev/null 2>&1
fi

%clean
%__rm -rf %{buildroot}

%files
%doc README.md ReleaseNotes.pdf
##CONTRIBUTORS.md LICENSE 
%defattr(-,root,root)
%{_usrsrc}/%{pname}-%{version}-%{release}
%config(noreplace) /etc/modprobe.d/50-8188eus.conf

%changelog
* Fri Apr 10 2020 onkelho <oh.quait at gmail.com> - 5.7.6.1-2pclos2020
- rebuild fix forkernel-5.6...

